// wrappit.cpp : Defines the entry point for the console application.
// 1.1

#undef _UNICODE
#define WIN32_LEAN_AND_MEAN
#include <stdio.h>
#include <tchar.h>
#include <windows.h>
#include <vector>
using namespace std;

struct EXPORT_ITEM
{
    bool IsOnlyOrdinal;
    char in[300];
    char en[300];
    int o;
    int h;
};

vector<EXPORT_ITEM> v;


#pragma warning(disable : 4996)

int main(int argc, char* argv[])
{
    printf("Wrappit. Copyright (C) Chourdakis Michael\r\n");
    printf("Usage: WRAPPIT <dll> <txt> <convention> <new dll name> <cpp> <def>\r\n");
    printf("==================================================================\r\n");

    if (argc < 7)
        return 0;

    // STEP 1: Read exports
    _tprintf(_T("Step 1: Parsing %s...\r\n"),argv[2]);
    FILE* fp = _tfopen(argv[2],_T("rb"));
    if (!fp)
    {
        printf("Error 1: Txt file not found.\r\n");
        return 0;
    }
    int MSStart = 0;
    for(int i = 0 ;; )
    {
        char x[1000] = {0};
        EXPORT_ITEM e = {0};
        if (!fgets(x,1000,fp))
            break;

        if (strnicmp(x,"EXPORT ord",10) == 0) // tdump
        {
            //EXPORT ord:1141='AcceptEx' => 'MSWSOCK.AcceptEx'
            e.o = atoi(x + 11);
            sprintf(e.in,"__E__%u__",i);
            char* y = strchr(x,'\'');
            if (y)
            {
                y++;
                char* y2 = strchr(y,'\'');
                if (y2)
                    *y2 = 0;
                strcpy(e.en,y);
                e.IsOnlyOrdinal = false;
            }
            else
            {
                e.IsOnlyOrdinal = true;
                sprintf(e.en,"___XXX___%u",i);
            }
            v.insert(v.end(),e);
        }
        else
        {
            if (strstr(x,"ordinal") != 0 && strstr(x,"hint") != 0 && strstr(x,"RVA") != 0)
            {
                MSStart = 1;
                continue;
            }
            if (!MSStart)
                continue;
            char* a1 = x;
            while(*a1 == ' ')
                a1++;
            if (*a1 == '\r' || *a1 == '\n')
            {
                if (MSStart == 1)
                {
                    MSStart = 2;
                    continue;
                }
                break;
            }
            e.o = atoi(a1);
            while(*a1 != ' ')
                a1++;
            while(*a1 == ' ')
                a1++;
            if (*a1 == '\r' || *a1 == '\n')
            {
                if (MSStart == 1)
                {
                    MSStart = 2;
                    continue;
                }
                break;
            }
            e.h = atoi(a1);
            while(*a1 != ' ')
                a1++;
            while(*a1 == ' ')
                a1++;
            if (*a1 == '\r' || *a1 == '\n')
            {
                if (MSStart == 1)
                {
                    MSStart = 2;
                    continue;
                }
                break;
            }
            if (*a1 >= 0x30 && *a1 <= 0x39) // RVA exists
            {
                while(*a1 != ' ')
                    a1++;
                while(*a1 == ' ')
                    a1++;
                if (*a1 == '\r' || *a1 == '\n')
                    break;
            }

            sprintf(e.in,"__E__%u__",i++);
            e.IsOnlyOrdinal = false;
            if (strnicmp(a1,"[NONAME]",8) == 0)
            {
                e.IsOnlyOrdinal = true;
                sprintf(e.en,"___XXX___%u",i);
            }
            else
            {
                for(int y = 0 ; ; y++)
                {
                    if (*a1 == ' ' || *a1 == '\r' || *a1 == '\n' || *a1 == '\t')
                        break;
                    e.en[y] = *a1++;
                }
            }
            v.insert(v.end(),e);
        }
    }
    fclose(fp);
    _tprintf(_T("Step 1: %u exported functions parsed.\r\n"),v.size());
    printf("------------------------------------------\r\n");

    _tprintf(_T("Step 2: Generating .DEF file %s...\r\n"),argv[6]);
    FILE* fdef = _tfopen(argv[6],_T("wb"));
    if (!fdef)
    {
        printf("Error 2: DEF file cannot be created.\r\n");
        return 0;
    }
    fprintf(fdef,"EXPORTS\r\n");
    for(unsigned int i = 0 ; i < v.size () ; i++)
    {
        if (v[i].IsOnlyOrdinal == false)
            fprintf(fdef,"%s=%s @%u\r\n",v[i].en,v[i].in,v[i].o);
        else
            fprintf(fdef,"%s=%s @%u NONAME\r\n",v[i].en,v[i].in,v[i].o);
    }
    fclose(fdef);
    _tprintf(_T("Step 2: %u exported functions written to DEF.\r\n"),v.size());
    printf("------------------------------------------\r\n");

    _tprintf(_T("Step 3: Generating .CPP file %s...\r\n"),argv[5]);
    FILE* fcpp = _tfopen(argv[5],_T("wb"));
    if (!fcpp)
    {
        printf("Error 3: CPP file cannot be created.\r\n");
        return 0;
    }

    fprintf(fcpp,"#include <windows.h>\r\n");
    fprintf(fcpp,"#include <vector>\r\n");
    fprintf(fcpp,"#include <string>\r\n");
    fprintf(fcpp,"#include <fstream>\r\n");
    fprintf(fcpp,"#include <Winbase.h>\r\n");
	fprintf(fcpp,"#include <time.h>\r\n");
	fprintf(fcpp,"\r\n\r\nconst unsigned int BUFFER_SIZE = 20000;\r\n\r\n");


    fprintf(fcpp,"struct LOG_PRIMITIVE_PARAMETERS\r\n");
    fprintf(fcpp,"{\r\n");
    fprintf(fcpp,"\tunsigned int param_val;\r\n");
    fprintf(fcpp,"\tbool     not_a_ref;\r\n");
    fprintf(fcpp,"\tchar param_as_ref[BUFFER_SIZE];\r\n");
    fprintf(fcpp,"};\r\n\r\n");
    fprintf(fcpp,"struct LOG_PRIMITIVE\r\n");
    fprintf(fcpp,"{\r\n");
    fprintf(fcpp,"public:\r\n");
    fprintf(fcpp,"\tstd::string function_name;\r\n");
	fprintf(fcpp,"\ttime_t call_time;\r\n");
    fprintf(fcpp,"\tchar stack_as_is[BUFFER_SIZE];\r\n");
    fprintf(fcpp,"\tstd::vector<LOG_PRIMITIVE_PARAMETERS> parameters;\r\n");
    fprintf(fcpp,"};\r\n");

    fprintf(fcpp,"std::vector<LOG_PRIMITIVE> log_vector;\r\n");

    fprintf(fcpp,"LOG_PRIMITIVE log_prim;\r\n");

    fprintf(fcpp,"CRITICAL_SECTION CriticalSection;\r\n");
    fprintf(fcpp,"unsigned int cur_ret_address;\r\n");
    fprintf(fcpp,"#pragma pack(1)\r\n\r\n\r\n");

    // Write variables
    fprintf(fcpp,"HINSTANCE hLThis = 0;\r\n");
    fprintf(fcpp,"HINSTANCE hL = 0;\r\n");
    fprintf(fcpp,"FARPROC p[%u] = {0};\r\n\r\n",v.size());
    fprintf(fcpp,"const char* function_names[%u] = {0};\r\n\r\n",v.size());

    // Write DllMain
    fprintf(fcpp,"BOOL WINAPI DllMain(HINSTANCE hInst,DWORD reason,LPVOID)\r\n");
    fprintf(fcpp,"\t{\r\n");
    fprintf(fcpp,"\tif (reason == DLL_PROCESS_ATTACH)\r\n");
    fprintf(fcpp,"\t\t{\r\n");

    fprintf(fcpp,_T("\t\thLThis = hInst;\r\n"),argv[4]);
    fprintf(fcpp,_T("\t\thL = LoadLibrary(\"%s\");\r\n"),argv[4]);
    fprintf(fcpp,"\t\tif (!hL) return false;\r\n");

    fprintf(fcpp,"\r\n\r\n");
    for(unsigned int i = 0 ; i < v.size () ; i++)
    {
        if (v[i].IsOnlyOrdinal == true)
        {
            fprintf(fcpp,"\t\tp[%u] = GetProcAddress(hL,(LPCSTR)\"%u\");\r\n",i,v[i].o);
            fprintf(fcpp,"\t\tfunction_names[%u] =\"%u\";\r\n", i, v[i].o);
        }
        else
        {
            fprintf(fcpp,"\t\tp[%u] = GetProcAddress(hL,\"%s\");\r\n",i,v[i].en);
            fprintf(fcpp,"\t\tfunction_names[%u] = \"%s\";\r\n",i, v[i].en);
        }
    }

    fprintf(fcpp,"\r\n\r\n\t\tInitializeCriticalSection(&CriticalSection);\r\n\r\n");
	fprintf(fcpp,"\r\n\r\n\t\t_tzset();\r\n\r\n");

    fprintf(fcpp,"\r\n\r\n");
    fprintf(fcpp,"\t\t}\r\n");

    fprintf(fcpp,"\tif (reason == DLL_PROCESS_DETACH)\r\n");
    fprintf(fcpp,"\t{\r\n");
    fprintf(fcpp,_T("\t\tFreeLibrary(hL);\r\n"));

    fprintf(fcpp,"\t\tDeleteCriticalSection(&CriticalSection);\r\n");
    fprintf(fcpp,"\t\tstd::ofstream result(\"dll_log.txt\", std::ios::binary);\r\n\r\n");

    fprintf(fcpp,"\t\tresult <<\"=====================================================\\n\";\r\n");
    fprintf(fcpp,"\t\tresult << \"list of functions called during execution\\n\";\r\n");
    fprintf(fcpp,"\t\tresult <<\"=====================================================\\n\";\r\n");

    fprintf(fcpp,"\t\tchar buf[100];\r\n");

    fprintf(fcpp,"\t\tfor(std::vector<LOG_PRIMITIVE>::const_iterator i = log_vector.begin(); i != log_vector.end(); i++)\r\n");
    fprintf(fcpp,"\t\t{\r\n");
    fprintf(fcpp,"\t\t\tctime_s(buf, 100, &i->call_time);\r\n");
    fprintf(fcpp,"\t\t\tresult << i->function_name << \"    called at \" << buf <<\" \\n\\n\";\r\n");
    fprintf(fcpp,"\t\t}\r\n");
        

    fprintf(fcpp,"\t\tfor(std::vector<LOG_PRIMITIVE>::const_iterator i = log_vector.begin(); i != log_vector.end(); i++)\r\n");
    fprintf(fcpp,"\t\t{\r\n");
    fprintf(fcpp,"\t\t\t\tresult <<\"=====================================================\\n\";\r\n");
    fprintf(fcpp,"\t\t\t\tresult << i->function_name << \"\\n\";\r\n");
    fprintf(fcpp,"\t\t\t\tresult <<\"=====================================================\\n\";\r\n");
    fprintf(fcpp,"\t\t\t\tresult << \"stack_as_is = \\n\";\r\n");
    fprintf(fcpp,"\t\t\t\tresult.write(&i->stack_as_is[0], sizeof(i->stack_as_is));\r\n");
    fprintf(fcpp,"\t\t\t\tresult <<\"\\n******************************\\n\";\r\n");

    fprintf(fcpp,"\t\t\t\tfor ( std::vector<LOG_PRIMITIVE_PARAMETERS>::const_iterator j = i->parameters.begin();\r\n");
    fprintf(fcpp,"\t\t\t\t\tj != i->parameters.end(); j++)\r\n");
    fprintf(fcpp,"\t\t\t\t{\r\n");
    fprintf(fcpp,"\t\t\t\t\tresult <<\"param_val =\" << j->param_val <<\"\\n\";\r\n");

    fprintf(fcpp,"\t\t\t\t\tif(!j->not_a_ref)\r\n");
    fprintf(fcpp,"\t\t\t\t\t{\r\n");
    fprintf(fcpp,"\t\t\t\t\t\tresult <<\"param_val_as_ref =\\n\";\r\n");
    fprintf(fcpp,"\t\t\t\t\t\tresult.write(&j->param_as_ref[0], sizeof(j->param_as_ref));\r\n");
    fprintf(fcpp,"\t\t\t\t\t\tresult <<\"\\n******************************\\n\";\r\n");
    fprintf(fcpp,"\t\t\t\t\t\tresult <<\"unsigned char array_val[] ={\";\r\n");
	fprintf(fcpp,"\t\t\t\t\t\tchar str_buf[10];\r\n");
    fprintf(fcpp,"\t\t\t\t\t\tfor(int i = 0; i < (sizeof(j->param_as_ref) - 1); i++ )\r\n");
	fprintf(fcpp,"\t\t\t\t\t\t{\r\n");
	fprintf(fcpp,"\t\t\t\t\t\t\tsprintf(str_buf, \"%s,\", (unsigned char)j->param_as_ref[i]);\r\n", "%#x");
    fprintf(fcpp,"\t\t\t\t\t\t\tresult << str_buf;\r\n");
	fprintf(fcpp,"\t\t\t\t\t\t}\r\n");
    fprintf(fcpp,"\t\t\t\t\t\tsprintf(str_buf, \"%s}\\n\\n\", (unsigned char)j->param_as_ref[(sizeof(j->param_as_ref) - 1)]);\r\n", "%#x");
	fprintf(fcpp,"\t\t\t\t\t\tresult << str_buf;\r\n");
	fprintf(fcpp,"\t\t\t\t\t\tresult <<\"\\n******************************\\n\";\r\n");

	fprintf(fcpp,"\t\t\t\t\t}\r\n");
    fprintf(fcpp,"\t\t\t\t}\r\n");
    fprintf(fcpp,"\t\t\t\tresult <<\"\\n\\n\\n\";\r\n");
    fprintf(fcpp,"\t\t}\r\n");
    fprintf(fcpp,"\t\tresult.close();\r\n");


    fprintf(fcpp,"\t\t}\r\n\r\n");


    fprintf(fcpp,"\treturn 1;\r\n");
    fprintf(fcpp,"\t}\r\n\r\n");


    fprintf(fcpp,"// __stdcall pop its argument itself(usually :) )\r\n");
    fprintf(fcpp,"void __stdcall add_log(const char * name, unsigned int r_esp_val)\r\n");
    fprintf(fcpp,"{\r\n");
    fprintf(fcpp,"\tEnterCriticalSection(&CriticalSection);\r\n");
    fprintf(fcpp,"\tlog_prim.parameters.clear();\r\n");
    fprintf(fcpp,"\t// skip the last element from stack since it's return address of callee\r\n");
    fprintf(fcpp,"\tunsigned int* cur_stack_ref = reinterpret_cast<unsigned int*>(r_esp_val + 4);\r\n");
    fprintf(fcpp,"\t__try\r\n");
    fprintf(fcpp,"\t{\r\n");
	fprintf(fcpp,"\t\tmemcpy(log_prim.stack_as_is, cur_stack_ref, BUFFER_SIZE);\r\n");
    fprintf(fcpp,"\t}\r\n");
    fprintf(fcpp,"\t__except(EXCEPTION_EXECUTE_HANDLER)\r\n");
    fprintf(fcpp,"\t{\r\n");
    fprintf(fcpp,"\t}\r\n");

    fprintf(fcpp,"\tfor(int i = 1; i < 10; i++)\r\n");
    fprintf(fcpp,"\t{\r\n");
    fprintf(fcpp,"\t\tLOG_PRIMITIVE_PARAMETERS parameter;\r\n");
    fprintf(fcpp,"\t\t__try\r\n");
    fprintf(fcpp,"\t\t{\r\n");
    fprintf(fcpp,"\t\t\tunsigned int* cur_stack_ref = reinterpret_cast<unsigned int*>(r_esp_val + i * 4);\r\n");
    fprintf(fcpp,"\t\t\tparameter.param_val = *cur_stack_ref;\r\n");
    fprintf(fcpp,"\t\t\tparameter.not_a_ref = false;\r\n");
    fprintf(fcpp,"\t\t\tcur_stack_ref = reinterpret_cast<unsigned int*>(*cur_stack_ref);\r\n");
    fprintf(fcpp,"\t\t\tmemset(&parameter.param_as_ref[0], 0, BUFFER_SIZE);\r\n");
    fprintf(fcpp,"\t\t\tmemcpy(&parameter.param_as_ref[0], cur_stack_ref, BUFFER_SIZE);\r\n");
    fprintf(fcpp,"\t\t}\r\n");
    fprintf(fcpp,"\t\t__except(EXCEPTION_EXECUTE_HANDLER)\r\n");
    fprintf(fcpp,"\t\t{\r\n");
    fprintf(fcpp,"\t\t\tparameter.not_a_ref = true;\r\n");
    fprintf(fcpp,"\t\t\tfor(int i = 0; i < BUFFER_SIZE; i++)\r\n");
    fprintf(fcpp,"\t\t\t{\r\n");
    fprintf(fcpp,"\t\t\t\tif(parameter.param_as_ref[i])\r\n");
    fprintf(fcpp,"\t\t\t\t{\r\n");
    fprintf(fcpp,"\t\t\t\t\tparameter.not_a_ref = false;\r\n");
    fprintf(fcpp,"\t\t\t\t\tbreak;\r\n");
    fprintf(fcpp,"\t\t\t\t}\r\n");
    fprintf(fcpp,"\t\t\t}\r\n");
    fprintf(fcpp,"\t\t}\r\n");
    fprintf(fcpp,"\t\tlog_prim.parameters.push_back(parameter);\r\n");
    fprintf(fcpp,"\t}\r\n");
    fprintf(fcpp,"\tlog_prim.function_name = name;\r\n");
    fprintf(fcpp,"\ttime(&log_prim.call_time);\r\n");
    fprintf(fcpp,"\tlog_vector.push_back(log_prim);\r\n");
    fprintf(fcpp,"\tLeaveCriticalSection(&CriticalSection);\r\n");
    fprintf(fcpp,"}\r\n");


    // Write function to be exported
    for(unsigned int i = 0 ; i < v.size() ; i++)
    {
        fprintf(fcpp,"// %s\r\nextern \"C\" __declspec(naked) void %s %s()\r\n",v[i].en,argv[3],v[i].in);
        fprintf(fcpp,"\t{\r\n");
        fprintf(fcpp,"\t__asm\r\n");
        fprintf(fcpp,"\t\t{\r\n");

        fprintf(fcpp,"\t\tmov   ecx, esp\r\n");      
        fprintf(fcpp,"\t\tmov	eax, DWORD PTR function_names[%u]\r\n", i * 4);
        fprintf(fcpp,"\t\tpush	ecx //   r_esp_val\r\n");     
        fprintf(fcpp,"\t\tpush	eax //   name\r\n");
        fprintf(fcpp,"\t\tcall	add_log\r\n");
        fprintf(fcpp,"\t\tpop ecx\r\n");
        fprintf(fcpp,"\t\tmov cur_ret_address, ecx\r\n");
        fprintf(fcpp,"\t\tcall p[%u*%u];\r\n",i,sizeof(void*));

        fprintf(fcpp,"\t\tpush cur_ret_address\r\n");
        fprintf(fcpp,"\t\tret\r\n");
        fprintf(fcpp,"\t\t}\r\n");
        fprintf(fcpp,"\t}\r\n\r\n");
    }

    fclose(fcpp);

    TCHAR ay[1000] = {0};
    return 0;
}

